
Redmine - Feature #21662

Search in issue assigned dropdown list

2016-01-07 16:37 - kunkka zhang

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: UI Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

My team used redmine over one year，now there are about 100 people in one project。

Everytime I create a issue ，I must assgin to somebody, and the dropdown list is tooooooo long, really hard to find the people I want

to assgin.

sorry about my english,can  somebody tell me to do fix it?

Related issues:

Related to Redmine - Feature #22275: Could search or input manually assignee ... New

Related to Redmine - Feature #1308: use ajax suggestion pattern to fill out s... New 2008-05-26

Has duplicate Redmine - Feature #26656: Search Assignee Closed

History

#1 - 2016-01-07 17:01 - Toshi MARUYAMA

- Category set to UI

- Priority changed from High to Normal

#2 - 2017-01-22 07:58 - Go MAEDA

- Related to Feature #22275: Could search or input manually assignee and target version added

#3 - 2017-01-22 08:06 - Go MAEDA

It would be great if "Assignee" drop-down has incremental search feature like "Jump to project" drop-down improved by #23310.

#4 - 2017-08-09 21:59 - Toshi MARUYAMA

- Has duplicate Feature #26656: Search Assignee added

#5 - 2017-10-27 10:04 - Tomomi Yuzuriha

- File autocomplete-issue-assigned-to_01@2x.png added

- File autocomplete-issue-assigned-to_02@2x.png added

- File autocomplete-issue-assigned-totrunk-r17004.patch added

+1 for kunkka zhang's idea!

I made the patch to implement this feature (compatible with latest trunk 17004).

This patch alows user to select assigner using incremental search.

Please see the screenshots below for the details.
https://www.redmine.org/issues/23310


autocomplete-issue-assigned-to_01@2x.png autocomplete-issue-assigned-to_02@2x.png 

Patch: autocomplete-issue-assigned-totrunk-r17004.patch

#6 - 2017-10-27 10:17 - Go MAEDA

Tomomi Yuzuriha, thank you for contributing to Redmine.
https://www.redmine.org/attachments/19403


I have just tried your patch and I noticed a problem. The problem is that "<< me >>" in the assignee list is removed by your patch. I think  this is a big

problem because "<< me >>" is very useful and probably many people use it.

I hope that "<< Me >>" will be available in your patch.

#7 - 2017-10-27 12:40 - Marius BĂLTEANU

This improvement looks very nice and it'll improve Redmine UI/UX. I'm wondering if it is possible to make this implementation like a widget or JS

function that can be reused easily in other parts from Redmine (eg: selects, add watchers, plugins).

#8 - 2017-11-07 01:10 - Tomomi Yuzuriha

- File gravatar_icon_none@2x.png added

- File gravatar_icon_present@2x.png added

- File 0001-Add-autcomplete-issue-assigned-to.patch added

- File 0002-Add-display-gravatar-on-assigners-list.patch added

Go Maeda, Thank you for your pointting out of my patch's problem.

Refering your comment, I changed the patch as follows.

Add "<< me >>" in assignee list

Add separator between Users and Groups

Please see the screenshot and patch below for the details.

 gravatar_icon_none@2x.png Patch: 0001-Add-autcomplete-issue-assigned-to.patch

Additionaly, Possible to add gravatar to the assignee list with the following patch.

 gravatar_icon_present@2x.png 

Patch: 0002-Add-display-gravatar-on-assigners-list.patch

#9 - 2017-11-08 05:09 - Akipii Oga

Tomomi Yuzuriha - san, +1 !

#10 - 2017-11-08 20:57 - Toshi MARUYAMA

- Subject changed from can enable to search people in dropdown list while assgin? to Search in issue assigned dropdown list

#11 - 2017-11-18 01:49 - Go MAEDA

- Target version set to 4.1.0

LGTM. Setting the target version to 4.1.0.

#12 - 2017-12-05 01:30 - Tomomi Yuzuriha

- File 0001-Add-autcomplete-issue-assigned-to.patch added

- File 0002-Add-display-gravatar-on-assigners-list.patch added

- File gravatar-icon-none@2x.png added

- File gravatar-icon-present@2x.png added

I changed the patch because the layout was corrupted as shown below on the specific browser(e.g. chrome, IE).

Layout with chrome:  
https://www.redmine.org/attachments/19629
https://www.redmine.org/attachments/19628


gravatar-icon-none@2x.png gravatar-icon-present@2x.png 

#13 - 2017-12-05 08:26 - Mischa The Evil

The screenshots look nice indeed. However, in my view

1

 there are some issues with this patch series in its current state

2

:

I'll start by saying that I agree with what Marius wrote in note#7: "[...] if it is possible to make this implementation like a widget or JS function that

can be reused easily in other parts from Redmine (eg: selects, add watchers, plugins)". I actually think it might even be a requirement.

This functionality is only implemented in the issues/_attributes.html.erb partial, while there are:

one: more current uses of principals_options_for_select that (might) need the same functionality:

ProjectsHelper#project_default_assigned_to_options

issues/bulk_edit.html.erb view

issue_categories/_form.html.erb view

two: other similar parts of the current Redmine core code and indeed even plugins that could benefit from this change (again referring to

Marius' quote here) [two other practical use-cases I though of were the user custom fields and even version selects (with the second one
I'm thinking especially about the currently sometimes very long lists)].

This becomes a problem (duplication) when the same functionality is being implemented in those other places too. Because of that it would

be better if most of the implementation (logic) is outside of the views/partials. I haven't looked up what the possibilities here exactly are but

what about an ApplicationHelper#principals_options_for_autocomplete or something? And what about some extraction/abstraction into (at

least) (a) reusable JS function(s)?

And btw: what about the raw usage? Is is safe? I'd have to look into it more closely.

Some typo-look-a-like, potentially ambiguous variable names: assignner_list & assigners. What about assignee(s)_list & assignees?

What about some top-padding for the groups separator? Maybe a little less padding around the items themselfs? Maybe style the separator like

the other opt-group implementations in Redmine

3

 by omitting the dashes and making the label bold. I should keep the icon in this case.

I see several CSS styles and li element styles. Does this affect themes/themeability? Transfer to application.css? Responsive styling ok? I

haven't tested it.

This is I think the biggest problem currently: this patch misses an equivalent of :required => @issue.required_attribute?('assigned_to_id')

introduced in r9977 for #703 and #3521.

All in all, I don't think that these patches are ready for integration yet.

1

 disclaimer one: I don't consider myself a JavaScript guru.

2

 disclaimer two: I haven't actually run this code myself (yet); I only did a (superficial) visual review of the patches from note#12.

3

 like: r6307, r13662, r15601, r16194.

#14 - 2018-01-03 11:22 - Toshi MARUYAMA

- Target version deleted (4.1.0)

Mischa The Evil wrote:

All in all, I don't think that these patches are ready for integration yet.

 What is current status?

#15 - 2018-03-28 08:54 - Mizuki ISHIKAWA

- File diff.patch added

- File using_select2.png added

I think that it is good to use select2 to realize this feature.

It is a plugin that provides an easy-to-use selection box.

This picture is actually a screenshot of the screen using select2.

 using_select2.png 

select2 is a popular plugin with many stars (22109) in GitHub.

https://github.com/select2/select2

By applying the attached patch you can use select 2 in Redmine for testing.

#16 - 2018-03-28 10:08 - Marius BĂLTEANU

Select2 could be a good solution, but Jean-Philippe Lang prefers to not use this library because it has a huge footprint (you can see here: #23310-11

).

#17 - 2018-03-29 01:31 - Go MAEDA

- Related to Feature #1308: use ajax suggestion pattern to fill out single potentially big fields, like "assigned to", "author" added

#18 - 2023-03-28 08:45 - Виктор Воеводский

+1

Files

autocomplete-issue-assigned-to_01@2x.png 66.1 KB 2017-10-27 Tomomi Yuzuriha

autocomplete-issue-assigned-to_02@2x.png 67.1 KB 2017-10-27 Tomomi Yuzuriha

autocomplete-issue-assigned-totrunk-r17004.patch 2.21 KB 2017-10-27 Tomomi Yuzuriha

gravatar_icon_none@2x.png 46.8 KB 2017-11-07 Tomomi Yuzuriha

gravatar_icon_present@2x.png 60 KB 2017-11-07 Tomomi Yuzuriha

0001-Add-autcomplete-issue-assigned-to.patch 3.4 KB 2017-11-07 Tomomi Yuzuriha

0002-Add-display-gravatar-on-assigners-list.patch 2.07 KB 2017-11-07 Tomomi Yuzuriha
0002-Add-display-gravatar-on-assigners-list.patch 2.08 KB 2017-12-05 Tomomi Yuzuriha

0001-Add-autcomplete-issue-assigned-to.patch 3.41 KB 2017-12-05 Tomomi Yuzuriha

gravatar-icon-none@2x.png 58 KB 2017-12-05 Tomomi Yuzuriha

gravatar-icon-present@2x.png 76.3 KB 2017-12-05 Tomomi Yuzuriha

diff.patch 1.13 KB 2018-03-28 Mizuki ISHIKAWA

using_select2.png 155 KB 2018-03-28 Mizuki ISHIKAWA
